require "amrita2/core"
require 'tmpdir'
require 'annotation'

module Amrita2
  # Ame[VΉ
  def self.make_default_spec1(e, option, spec_stack, type_map)
    key_attr = option[:key_attr_name].to_s
    id_ = e.attributes[key_attr]
    if id_

      # C
      opt = get_option(e, option, type_map)
      id_original = id_
      id_ = "amview_#{id_}" unless /^amview_/.match(id_)
      e.add_attribute(key_attr, id_)
      model_class = AmritaHandler::PageContext.find_model_class(specs2idtree(spec_stack))
      AmritaHandler::ViewComponent.registered.each do |ann, component|
        if model_class.ann_include?(ann, id_original.intern)
          opt.update(component.spec_option)
        end
      end
      sym = id_.intern
      # C܂

      s = Core::DynamicElementSpec.new(sym, nil, opt)
      s.parent = spec_stack.first
      spec_stack.first.children << s
      spec_stack.unshift(s)
      e.elements.each do |c|
        make_default_spec1(c, option, spec_stack, type_map)
      end
      spec_stack.shift
    else
      e.elements.each do |c|
        make_default_spec1(c, option, spec_stack, type_map)
      end
    end
  end
  
  # ǉ
  def self.specs2idtree(specs)
    idtree = []
    specs.each do |spec|
      if spec.instance_of?(Core::DynamicElementSpec)
        idtree.unshift(spec.sym.to_s.sub(/^amview_/, ''))
      end
    end
    idtree
  end

  def self.get_option(e, option, type_map)
    ret = option.clone
    a = e.attributes
    if typ = a['amrita:type']
      default_opt = type_map[typ.intern]
      ret.merge!(default_opt) if default_opt
      a.delete('amrita:type')
    end
    if opt = a['amrita:option']
      ret.merge!(eval("{#{opt} }"))
      a.delete('amrita:option')
    end
    ret
  end

end


module Amrita2::Extention
  # symƂɓ삵ȂoOC
  module SelectionElement
    private
    def complie_for_selection(element, dyn_spec, cg, opts)
      select_attr, children = *opts
      children = element.elements  if element.elements.size > 0
      gen_element_with_attr(element, dyn_spec, cg)
      children.each do |c|
        sym = c.attributes["value"].intern
        cg.code("a = #{c.attributes.inspect}")
        cg.code("a[#{select_attr.inspect}] = '#{select_attr.to_s}' if val and val.to_s.size > 0 and val.to_s.intern == :'#{sym.to_s}' ")
        cg.code("c = new_element(#{c.name.intern.inspect}, a)")
        cg.code("c.text = #{c.text.inspect}") if c.text
        cg.code("e.add(c)")
      end
      cg.code("get_mainstream << e.to_s")
    end
  end
  
  # WI{^pg
  module RadioSelectionElement
    extend Amrita2::Core::SpecOptionMeta::CompilerOption
    def self.check_option(spec, k, v)
      spec.option[:check_true] = spec.option[:replace_attr] = false
    end
    def code_for_leaf_element(element, dyn_spec, cg, &block)
      cg.code('include Amrita2::Runtime')
      sym = dyn_spec.sym
      cg.define_element_method(sym, dyn_spec.output_stream) do
        complie_for_selection(element, dyn_spec, cg, dyn_spec.option[:radio_selection_element])
      end
    end

    private

    def complie_for_selection(element, dyn_spec, cg, opts)
      check_attr, children = *opts
      children = element.elements  if element.elements.size > 0
      gen_element_with_attr(element, dyn_spec, cg)
      children.each do |c|
        sym = c.attributes["value"].intern
        cg.code("a = #{c.attributes.inspect}")
        cg.code("a['name'] = attrs[:name]")
        cg.code("a[#{check_attr.inspect}] = '#{check_attr.to_s}' if val and val.to_s.size > 0 and val.to_s.intern == :'#{sym.to_s}' ")
        cg.code("c = new_element(#{c.name.intern.inspect}, a)")
        cg.code("c.text = #{c.text.inspect}") if c.text
        cg.code("e.add(c)")
      end
      cg.code("get_mainstream << e.to_s")
    end

    Amrita2::Core::SpecOptionMeta::define_option(:radio_selection_element, self)
  end
end

# RpCR[hfobO₷
class Amrita2::Core::RootSpec
  def create_template_module(e, doc=nil)
    m = Module.new
    result = create_template_module_text(e)
    tmpname = Dir.tmpdir.to_s + '/template_module.rb'
    open(tmpname, 'w') {|f| f.puts result}  if $DEBUG
    m.module_eval(result, tmpname)
    if doc
      m.const_set(:XmlDecl, doc.xml_decl.to_s)
      m.const_set(:DocType, doc.doctype.to_s)
    end
    m
  end
end
