require 'webrick'
require 'webrick/httpstatus'
require './session'
require "amrita2/template"
require 'viewcomponent'
require 'amrita2_extension'
require 'rexml/document'

include Amrita2

class Object
  def writable_properties
    ms = self.methods
    ms.reject! {|m| m[-1, 1] != '='}
    ms.each do |m|
      m.chop!
    end
    ms
  end
end


module AmritaHandler
  def registry
    @@registry
  end

  def dynamic_class_load(class_name)
    class_name_down = class_name.downcase
    exact_name = nil
    
    Module.constants.each do |c|
      if c.downcase == class_name_down
        exact_name = c
        break
      end
    end
#    raise NameError.new("undefined class name", class_name) unless exact_name
    clazz = Module::const_get(exact_name)
    raise NameError.new("undefined class name", class_name) unless clazz.instance_of?(Class)
    clazz
  end  

  def build_processor(clazz, req)
    instance = clazz.new
    keys = instance.reader_methods & req.query.keys
    keys.each do |k|
      instance.__send__("#{k}=", req.query[k])
    end
    instance
  end
  
  def inject_parameter(default_obj, req)
    req_params = { default_obj=>{} }
    req.query.each do |k, v|
      if m = /(.*)_(\d+)$/.match(k)
        prop = m.to_a[1]
        id = m.to_a[2].to_i
        obj2 = ObjectSpace::_id2ref(id) rescue next
        req_params[obj2] ||= {}
        req_params[obj2][prop] = v
      else
        req_params[default_obj][k] = v
      end
    end

    # sessionɊi[Ă̂H
    req.session['pos'] ||= {}
    pos = req.session['pos']
    #p pos if $DEBUG
        
    req_params.each do |obj, param|
      if pos.has_key?(obj)
        pos[obj].each do |vc|
          vc.inject_parameter(param)
        end
      elsif ViewComponent.prototypes.has_key?(obj.class)
        vcs = []
        ViewComponent.prototypes[obj.class].each do |vc|
          vc2 = vc.dup
          vc2.owner_object = obj
          vc2.inject_parameter(param)
          vcs << vc2
        end
        pos[obj] = vcs
      end
    end
    req.session['pos'] = pos

=begin        
    req_params.each do |obj, param|
      
      ViewComponent.prototypes.each do |vc|
        if obj.class == vc.owner_class
          vc.inject_parameter(obj, param)
        end
      end
    end
=end

  end
  module_function :registry, :dynamic_class_load, :build_processor, :inject_parameter

  class AmritaViewHandler < WEBrick::HTTPServlet::DefaultFileHandler
  
    def do_GET(req, res)
      #local_script = @local_path.sub(/\.html$/, '')
      #local_script += '.rb'
      page_name = File.basename(req.path, '.html')
      #if File.exist?(local_script)
      req.class.module_eval %Q{ attr_accessor :session }
      req.session = WEBrick::Session.new(req, res, 'database_manager'=>WEBrick::Session::MemoryStore)

        #class_name = File.basename(local_script, '.rb')
        #load(local_script)
  
        #clazz = AmritaHandler::dynamic_class_load(class_name)
        #instance = AmritaHandler::build_processor(clazz, req)
      if instance = AmritaHandler.registry[page_name.downcase.to_sym]
        AmritaHandler::PageContext.set(page_name.downcase, instance)
        AmritaHandler.inject_parameter(instance, req)
        
        if instance.respond_to?(:preprocess)
          instance.__send__(:preprocess)
        end
        
        tmpl = TemplateFile.new(@local_path)

        out = ""
        tmpl.expand(out, instance)
        res.body = out
        req.session.update
      else
        super
      end
      
    end
    
    def do_POST(req, res)
      res.header['Allow'] = 'GET'
      raise HTTPStatus::MethodNotAllowed
    end
  
  end
  
  
  class AmritaActionHandler < WEBrick::HTTPServlet::DefaultFileHandler
  
    def do_POST(req, res)
      # TODO: rbt@C݂ꍇ̂݌ĂяôC
      req.class.module_eval %Q{ attr_accessor :session }
      req.session = WEBrick::Session.new(req, res, 'database_manager'=>WEBrick::Session::MemoryStore)

      class_name = File.basename(req.path, '.rb')
      #class_name = File.basename(@local_path, '.rb')
      #load(@local_path)
      
      #clazz = AmritaHandler::dynamic_class_load(class_name)
      #instance = AmritaHandler::build_processor(clazz, req)
      instance = AmritaHandler.registry[class_name.downcase.to_sym]
      AmritaHandler::PageContext.set(class_name.downcase, instance)
      AmritaHandler.inject_parameter(instance, req)
      
      result = nil
      req.query.keys.each do |k|
        method = k.to_sym
        if instance.class.const_defined?(:ATTR_ACTION)
          actions = instance.class.const_get(:ATTR_ACTION)
          result2 = instance.__send__(method) if actions.include?(method) and instance.respond_to?(method)
          result = result2 if result2
        else
          result2 = instance.__send__(method) if instance.respond_to?(method)
          result = result2 if result2
        end
      end
      if instance.respond_to?(:action)
        result2 = instance.__send__(:action)
        result = result2 if result2
      end
      
      req.session.update
      forwarding = File.dirname(req.path) + '/'
      forwarding << result + '.html' if result
      # 303 See Other ĝ|Cg
      res.set_redirect(HTTPStatus::SeeOther, forwarding)
    end
  
    def do_GET(req, res)
      res.header['Allow'] = 'POST'
      raise HTTPStatus::MethodNotAllowed
    end
  end
  
  class PageContext
    attr_reader :root_name, :root_po
    def initialize(name, object, opt)
      @root_name = name.to_s
      @root_po = object
      @root_opt = opt
      #@clazz = object.class
    end
    def self.set(name, object, opt = {:key_attr_name => :id})
      Thread.current[:PageContext] = PageContext.new(name, object, opt)
    end
    def self.current
      Thread.current[:PageContext]
    end
    def self.current_po(e = nil)
      return current.root_po unless e
      s = e
      if e.instance_of?(REXML::Element)
        s = e.attributes['name']
#        if s
#          id = e.attributes[@root_opt[:key_attr_name].to_s]
#          while p = e.parent
#            if p.attributes[@root_opt[:key_attr_name].to_s]
#          end
#        end
      end
      if m = /(.*)_(\d+)$/.match(s)
        prop = m.to_a[1]
        id = m.to_a[2].to_i
        ObjectSpace._id2ref(id) rescue current.root_po
      else
        current.root_po
      end
    end
    def self.find_model_class(idtree)
      obj = current.root_po
      idtree.each do |id|
        obj = obj.first if obj.instance_of?(Array)
        begin
          obj = obj.__send__(id)
        rescue NameError
          begin
            if obj[id] != nil
              obj = obj[id]
            else
              raise NameError
            end
          rescue NameError
            obj = nil
            break
          end
        end
      end
      obj = obj.first if obj.instance_of?(Array)
      obj.class
    end
  end

  
  def setup(webapp, sources, registry)
    @@registry = registry
    sources.each do |rb|
      File.open(rb) do |f|
        webapp.module_eval(f.read, rb)
      end
    end
    #p webapp.constants if $DEBUG

    # NeedleWXgɎo^
    Annotation::ScanHandler.register_after do |const|
      if const.instance_of?(Class)
        clazz = const
        id = clazz.name.sub(/^.*::/, '').downcase.to_sym
        instance = :singleton
        if clazz.const_defined?(:INSTANCE)
          instance = clazz.const_get(:INSTANCE)
        end
        if clazz.const_defined?(:INIT_PARAM)
          init_param = clazz.const_get(:INIT_PARAM)
          init_param = [init_param] unless init_param.instance_of?(Array)
          param_str = init_param.collect!{|p| 'c.' + p.to_s }.join(', ')
          eval %Q{
            @@registry.register(id, :model => instance) {|c, p| clazz.new(#{param_str}) }
          }
        else
          @@registry.register(id, :model => instance) {|c, p| clazz.new }
        end
        puts "Registered managed instance: #{id} (#{instance})" if $DEBUG
      end
    end

    # Ame[VXLiViewComponentprototypej
    Annotation::ScanHandler.scan(webapp)

=begin    
    webapp.constants.each do |const|
      clazz = webapp.const_get(const)
      if clazz.instance_of?(Class)
        reader_props = clazz.instance_methods(true) - Object.instance_methods(true)
        reader_props.reject! {|m| m[-1, 1] == '='}
        puts "Class #{clazz.name} readers: #{reader_props.inspect}" if $DEBUG
        # ftHgr[\bh
        reader_props.each do |method|
          clazz.module_eval %Q{
            def amview_#{method}
              #{method}
            end
          }
        end

        # 萔Ame[Vǂݎ
        ViewComponent.registered.each do |ann, component|
          if clazz.const_defined?(ann)
            attrs = clazz.const_get(ann)
            attrs = [attrs] unless attrs.instance_of?(Array)
            attrs.each do |attr|
              vc = component.new(clazz, attr)
              ViewComponent.prototypes[clazz] ||= []
              ViewComponent.prototypes[clazz] << vc
            end
          end
        end
      end
    end
=end

    # r[\bh`
    ViewComponent.prototypes.each do |clazz, vcs|
      vcs.each do |vc|
        vc.define_view_method
      end
    end
    
  end
  module_function :setup

  CONFIG = {
    :NondisclosureName => [".ht*", "*~"],
    :FancyIndexing     => true,
    :HandlerTable      => {'html'=>AmritaViewHandler, 'rb'=>AmritaActionHandler},
    :HandlerCallback   => nil,
    :DirectoryCallback => nil,
    :FileCallback      => nil,
    :UserDir           => nil,
    :AcceptableLanguages => ['en', 'ja']  # ["en", "ja", ... ]
  }

end

