module ConstantAnnotation
  
  class ScanHandler
    @@registry = {}
    @@before = []
    @@after = []
    def self.register(ann, value = nil, &block)
      @@registry[ann] = [value, block]
    end
    def self.register_before(&block)
      @@before << block
    end
    def self.register_after(&block)
      @@after << block
    end
    def self.registered?(ann)
      @@registry.has_key?(ann)
    end
    def self.registered_value(ann)
      @@registry[ann][0]
    end
    def self.registered_proc(ann)
      @@registry[ann][1]
    end

    # 萔Ame[Vǂݎ
    def self.scan(mod)
      @@before.each do |proc|
        proc.call(mod)
      end
      mod.constants.each do |const_name|
        const = mod.const_get(const_name)
        case const
        when Module
          scan(const) if /^#{mod.name}/ =~ const.name
        when Symbol, Array, Hash
          ann_name = const_name
          const = [const] unless const.instance_of?(Array)
          const.each do |value|
            flag = true
            if value.instance_of?(Hash)
              flag = false
              flag = true if value[:name].instance_of?(Symbol)
            end
            puts "Annotation: #{ann_name} => #{value.inspect}" if $DEBUG
            if registered?(ann_name.to_sym) and flag
              registered_proc(ann_name.to_sym).call(mod, value)
            end
          end
        else
          # 
        end
      end
      @@after.each do |proc|
        proc.call(mod)
      end
    end

  end
end

module Annotation
  # ܂̂ƂGCAX
  ScanHandler = ConstantAnnotation::ScanHandler
end

class Module
  def ann_include?(name, value = nil)
    if not value
      const_defined?(name)
    elsif const_defined?(name)
      ann = const_get(name)
      if ann.to_ary.include?(value)
        true
      else
        ann.to_ary.each do |h|
          if h.instance_of?(Hash) and h[:name] == value
            return true
          end
        end
        false
      end
    else
      false
    end
  end
end
